// FlickerFreeDemoDlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "memdc.h"
#include "FlickerFreeDemo.h"
#include "FlickerFreeDemoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg-Dialogfeld fr Anwendungsbefehl "Info"

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialogfelddaten
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung

// Implementierung
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CFlickerFreeDemoDlg-Dialogfeld




CFlickerFreeDemoDlg::CFlickerFreeDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFlickerFreeDemoDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CFlickerFreeDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CFlickerFreeDemoDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


// CFlickerFreeDemoDlg-Meldungshandler

BOOL CFlickerFreeDemoDlg::OnInitDialog()
{
	SetTimer(1, 33, NULL);

	CDialog::OnInitDialog();

	CRect rect;
	GetClientRect(&rect);
	
	int delta_x = rect.right - rect.left;
	int delta_y = rect.bottom - rect.top;
	PixelArray.SetSize(delta_x, delta_y);

	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}

void CFlickerFreeDemoDlg::OnTimer(UINT nIDEvent) 
{
	CRect client;
	GetClientRect(&client);
	Invalidate();
}

BOOL CFlickerFreeDemoDlg::OnEraseBkgnd(CDC* pDC)
{
	return FALSE;
}

void CFlickerFreeDemoDlg::OnPaint()
{	
	CPaintDC dc(this);
	CMemDC pDC(&dc);

	CRect rect;
	GetClientRect(&rect);
	
	int delta_x = rect.right - rect.left;
	int delta_y = rect.bottom - rect.top;
	
	PixelArray.IterateNewContent();

	COLORREF color;
	for (int x=0; x< delta_x; x++) 
	{
		for (int y=0; y< delta_y; y++) 
		{
			color = PixelArray.m_Array[x][y];
			pDC->SetPixel(x,y,color);
		}
	}

	CDialog::OnPaint();
}

// Die System ruft diese Funktion auf, um den Cursor abzufragen, der angezeigt wird, whrend der Benutzer
//  das minimierte Fenster mit der Maus zieht.
HCURSOR CFlickerFreeDemoDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

